/* -*- mode: c++ -*-
 * Header    :
 * File      : common.hxx
 * Auther    : Kosuke Shinoda
 * Since     : <03/11/14 21:03:44 kshinoda>
 * Time-stamp: <08/02/18 12:18:43 kshinoda>
 * Comment   :
 * End       :
 */
/*
 * ScaleFreeNetwork Simulator
 * Copyright (C)2003 SHINODA, Kosuke. Jaist,Japan & CARC, AIST, JAPAN
 * Copyright (C)2004 SHINODA, Kosuke. Jaist,JAPAN
 */
#ifndef __FreeNet_common_hxx__
#define __FreeNet_common_hxx__

//#include "itk/itk.h"

#include <boost/graph/adjacency_list.hpp>
#include <boost/property_map.hpp>
#include <boost/graph/graphviz.hpp>

//using namespace Itk;
using namespace std;
using namespace boost;

/**
 *
   * ɽ
   */
typedef adjacency_list <vecS, vecS, undirectedS,
  property <vertex_name_t, int,
  property <vertex_index1_t, float,
  property <vertex_distance_t, int, 
  property <vertex_discover_time_t, float,
  property <vertex_degree_t, int,
  property <vertex_priority_t, float> > > > > >, 
  property <edge_name_t, std::string, 
  property <edge_weight_t, int> >, GraphvizGraphProperty > SocialNetwork;

typedef graph_traits<SocialNetwork>::vertex_descriptor Vertex;
typedef graph_traits<SocialNetwork>::edge_descriptor Edge;

typedef graph_traits<SocialNetwork>::vertex_iterator VIter;
typedef graph_traits<SocialNetwork>::edge_iterator EIter;
typedef graph_traits<SocialNetwork>::adjacency_iterator AIter;
typedef graph_traits<SocialNetwork>::out_edge_iterator OEIter;

typedef property_map<SocialNetwork, vertex_name_t>::type NameMap;
typedef property_map<SocialNetwork, vertex_index1_t>::type ClusteringMap;
typedef property_map<SocialNetwork, vertex_distance_t>::type DistanceMap;
typedef property_map<SocialNetwork, vertex_degree_t>::type DegreeMap;
typedef property_map<SocialNetwork, vertex_priority_t>::type EvalValueMap;

typedef property_map<SocialNetwork, edge_weight_t>::type WeightMap;

typedef std::pair<Vertex, Vertex> BindVertices;
typedef map<BindVertices, float> VotingTable;

//typedef VectorT<Vertex> VertexVector;
typedef vector<Vertex> VertexVector;
//typedef ListT<Vertex> VerticesL;
typedef list<Vertex> VerticesL;
typedef vector<BindVertices> EdgesList;
typedef vector<BindVertices> BindVerticesVector;

typedef vector<float> ScoreTable;
typedef vector<int> DistTable;

#endif
